<?php

define('TXTBEAR_VERSION', '1.1.8');

function decodeChunked($strText) {
	$intLength = 0;
	$strDecoded = '';
	$i = 0;
	$intAntiOverflow = 0;
	do {
		$intBreak = strpos($string, "\r\n", $i);
		$strChunk = substr($strText, $i, $intBreak - $i);
		$i += strlen($strChunk) + 2;
		$strChunk = hexdec($strChunk);
		if($strChunk == 0)
			break;
		$strDecoded .= substr($strText, $i, $strChunk);
		$i += $strChunk + 2;
		if($i > strlen($strText))
			break;
	} while($intAntiOverflow++ < 1000);

	return $strReply;
}

function get($strUrl) {
	$arrUrl = parse_url($strUrl);
	$intErr = 0;
	$strErr = '';
	$resFp = false;
	$resFp = @fsockopen($arrUrl['host'], 80, $intErr, $strErr, 3.0);
	if(!$resFp)
		return array(12027, '');
	$strQuery = isset($arrUrl['query']) ? '?'.$arrUrl['query'] : '';
	fwrite($resFp,
		'GET '.$arrUrl['path'].$strQuery." HTTP/1.1\r\n" .
		'Host: '.$arrUrl['host']."\r\n" .
		'Referer: '.WP_SITEURL."\r\n" .
		"User-Agent: txtbear ".TXTBEAR_VERSION."\r\n" .
		"Connection: Close\r\n\r\n");
	$strData = '';
	while(!feof($resFp))
		$strData .= fread($resFp, 1024);
	fclose($resFp);
	$intStatus = intval(substr($strData, strpos($strData, 'HTTP/') + 9, 5));
	$boolChunked = !!stristr($strData, 'Transfer-Encoding: chunked');
	$strData = substr($strData, strpos($strData, "\r\n\r\n") + 4);
	if($boolChunked)
		$strData = decodeChunked($strData);
	return array('status' => $intStatus, 'data' => $strData);
}

function txtbear_admin_is_german() {
	return in_array(get_option('txtbear_admin_country'), explode(' ', 'Germany Austria Switzerland Liechtenstein'));
}
